#include <STC8H.H>
#include <intrins.h>
#include <absacc.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h>
#include <math.h>
	
#define		FOSC			24000000UL					//ʱ
#define		BAUD			115200UL					//
#define		TMRF			200UL						//ʱƵ
#define		BRT				(0x10000-(FOSC/BAUD+2)/4)	//ֵ
#define		TMR				(0x10000-FOSC/TMRF/12)		//ʱֵ
#define		T_Buf_Len		64							//Uart1ͻ泤
#define		R_Buf_Len		64							//Uart1ջ泤

unsigned char		RP;					//Uart1ָ
unsigned char		TP;					//Uart1ָ
unsigned char		Uart_R_Len;			//Uart1ճ
unsigned char		Uart_T_Len;			//Uart1ͳ
unsigned char xdata	R_Buf[R_Buf_Len];	//Uart1ջ
unsigned char xdata	T_Buf[T_Buf_Len];	//Uart1ͻ

void Delay_ms(unsigned char ms)
{
	unsigned int i;
	do
	{
		i=FOSC/10000;
		while(--i);	//10T per loop
	}
	while(--ms);
}

void UART_Send(unsigned int x)
{
	TP=0;
	Uart_T_Len=x;
	TI=1;
}

void Uart_Printf(unsigned char *v,...)
{
	va_list ap;
	va_start(ap,v);
	while(Uart_T_Len);
	UART_Send(vsprintf(T_Buf,v,ap));
	va_end(ap);
}

void UART_Return(unsigned char temp)
{
	memcpy(T_Buf,R_Buf,temp);
	UART_Send(temp);
}

void Init(void)
{
	P_SW2|=EAXFR;
	
	P0M1=0x00;	P0M0=0x00;	//Ϊ׼˫
	P1M1=0x00;	P1M0=0x00;	//Ϊ׼˫
	P2M1=0x00;	P2M0=0x00;	//Ϊ׼˫
	P3M1=0x00;	P3M0=0x00;	//Ϊ׼˫
	P4M1=0x00;	P4M0=0x00;	//Ϊ׼˫
	P5M1=0x00;	P5M0=0x00;	//Ϊ׼˫
	P6M1=0x00;	P6M0=0x00;	//Ϊ׼˫
	P7M1=0x00;	P7M0=0x00;	//Ϊ׼˫
	
//	P0IE=0x00;
//	P1IE=0x00;
//	P2IE=0x00;
//	P3IE=0x00;
//	P4IE=0x00;
//	P5IE=0x00;
//	P6IE=0x00;
//	P7IE=0x00;
	
	AUXR=0x05;		//öʱ0ʱΪ12Tģʽöʱ2Ϊ1Tģʽöʱ2Ϊʷ
	TMOD=0x01;		//öʱ0Ϊ16λԶװģʽ
	TH0=TMR>>8;		//öʱ0ʼֵ
	TL0=TMR;		//öʱ0ʼֵ
	TF0=0;			//TF0жϱ־λ
	ET0=1;			//öʱ0ж
	
	SCON=0x50;		//UART1ģʽΪ8λݿɱ䲨
	T2H=BRT>>8;		//UART1
	T2L=BRT;		//UART1
	AUXR|=T2R;		//򿪶ʱ2
	ES=1;			//UART1ж
	
	EA=1;			//ж
}

void main(void)
{
	Init();
	while(1)
	{
		Uart_Printf("P0IE=0x%02bX\r\n",P0IE);
		Uart_Printf("P1IE=0x%02bX\r\n",P1IE);
		Uart_Printf("P2IE=0x%02bX\r\n",P2IE);
		Uart_Printf("P3IE=0x%02bX\r\n",P3IE);
		Uart_Printf("P4IE=0x%02bX\r\n",P4IE);
		Uart_Printf("P5IE=0x%02bX\r\n",P5IE);
		Uart_Printf("P6IE=0x%02bX\r\n",P6IE);
		Uart_Printf("P7IE=0x%02bX\r\n",P7IE);
		Uart_Printf("\r\n");
		Uart_Printf("P0=0x%02bX\r\n",P0);
		Uart_Printf("P1=0x%02bX\r\n",P1);
		Uart_Printf("P2=0x%02bX\r\n",P2);
		Uart_Printf("P3=0x%02bX\r\n",P3);
		Uart_Printf("P4=0x%02bX\r\n",P4);
		Uart_Printf("P5=0x%02bX\r\n",P5);
		Uart_Printf("P6=0x%02bX\r\n",P6);
		Uart_Printf("P7=0x%02bX\r\n",P7);
		Uart_Printf("\r\n");
		Delay_ms(250);
		Delay_ms(250);
		Delay_ms(250);
		Delay_ms(250);
	}
}

void Uart_Start(void)
{
	TH0=TMR>>8;
	TL0=TMR;
	TR0=1;
}

void Uart_Stop(void)
{
	TR0=0;
	TH0=TMR>>8;
	TL0=TMR;
	RP=0;
	memset(R_Buf,0x00,sizeof R_Buf);
}

void TMR0_Isr(void) interrupt TMR0_VECTOR
{
	UART_Return(RP);
	Uart_Stop();
}

void UART1_Isr(void) interrupt UART1_VECTOR
{
	if(RI)
	{
		RI=0;
		Uart_Start();
		R_Buf[RP]=SBUF;
		if(RP==R_Buf_Len-1)
		{
			Uart_Stop();
		}
		else if(TR0)
		{
			RP++;
		}
	}
	if(TI)
	{
		TI=0;
		if(TP==Uart_T_Len)
		{
			TP=0;
			Uart_T_Len=0;
		}
		if(Uart_T_Len!=0)
		{
			SBUF=(T_Buf[TP]);
			TP++;
		}
	}
}